Section Widening_chains.
Variable S : Set.
Hypothesis domain_le : S -> S -> Prop.
Hypothesis domain_le_decide :
    forall x y : S,
      { domain_le x y } + {~ (domain_le x y) }.

Inductive widening_chain: Set :=
  widening_chain_intro : forall x : S,
    (forall y : S, widening_chain + {domain_le y x}) -> widening_chain.

Section Recursor.
Variable f : S -> S.

Fixpoint abstract_lfp_rec
  (iteration_step : widening_chain) :
  { lfp : S | domain_le (f lfp) lfp } :=
  let (x, xNext) := iteration_step in
  match xNext (f x) with
  | inleft next_widening_chain => abstract_lfp_rec next_widening_chain
  | inright fx_less_than_x => exist (fun x => domain_le (f x) x)
      x fx_less_than_x
  end.
End Recursor.
End Widening_chains.
